/////////////////////////////////////////////////////////////////////////////////
function Projection()
{
} // Projection

Projection.prototype.project = function (inPoint3D)
{
	var oPoint = new Point(inPoint3D.x, inPoint3D.y);
	
	return oPoint;
} // project

/////////////////////////////////////////////////////////////////////////////////
function ProspectiveProjection(inView, inCameraPosition, inLookAt, inUp)
{
	TODO: I think the order of the matrix multiplication needs to 
	be reversed foreach multiply.
	this.viewX = inView.x;
	this.viewY = inView.y;
	this.viewZ = inView.z;
	this.viewWidth = inView.width;
	this.viewHeight = inView.height;
	this.viewDepth = inView.depth;
	this.widthToHeightRatio = this.viewWidth / this.viewHeight;
	this.eyeZ = inCameraPosition;
	this.eyeZ.flip();
	
	var oEyeX = inUp.crossProduct(this.eyeZ);
	var oEyeY = this.eyeZ.crossProduct(oEyeX);
	var oWorldToEyeRotationMatrix = new Matrix4x4();
	var oWorldToEyeTranslationMatrix = new Matrix4x4();
	
	oWorldToEyeRotationMatrix.identity();
	oWorldToEyeRotationMatrix.set(0, 0, oEyeX.x);
	oWorldToEyeRotationMatrix.set(1, 0, oEyeX.y);
	oWorldToEyeRotationMatrix.set(2, 0, oEyeX.z);
	oWorldToEyeRotationMatrix.set(0, 1, oEyeY.x);
	oWorldToEyeRotationMatrix.set(1, 1, oEyeY.y);
	oWorldToEyeRotationMatrix.set(2, 1, oEyeY.z);
	oWorldToEyeRotationMatrix.set(0, 2, this.eyeZ.x);
	oWorldToEyeRotationMatrix.set(1, 2, this.eyeZ.y);
	oWorldToEyeRotationMatrix.set(2, 2, this.eyeZ.z);
	
	oWorldToEyeTranslationMatrix.identity();
	oWorldToEyeTranslationMatrix.set(3, 0, -inCameraPosition.x);
	oWorldToEyeTranslationMatrix.set(3, 1, -inCameraPosition.y);
	oWorldToEyeTranslationMatrix.set(3, 2, -inCameraPosition.z);

	var oWorldToEyeMatrix = oWorldToEyeRotationMatrix.multiplyMatrix(oWorldToEyeTranslationMatrix);
	
	var fHalfHeight = this.viewHeight / 2;
	var fFar = this.viewZ + this.viewDepth;
	var fFarDistanceFromEye = fFar - inCameraPosition.z;
	var fHypotenuse = Math.sqrt((fHalfHeight * fHalfHeight) + (fFarDistanceFromEye * fFarDistanceFromEye));
	var fAngle = (Math.acos((-fHalfHeight * fHalfHeight + fFarDistanceFromEye * fFarDistanceFromEye + fHypotenuse * fHypotenuse) / (2 * fFarDistanceFromEye * fHypotenuse))) * (180 / Math.PI);
	var fAspect = this.viewWidth / this.viewHeight;
	var fNearTop = Math.abs(this.viewZ) * Math.tan(fAngle);
	var fNearTopx2 = fNearTop * 2;
	var fNearBottom = -fNearTop;
	var fNearRight = fNearTop * fAspect;
	var fNearLeft = -fNearRight;
	//var fNearTop = 50;
	//var fNearTopx2 = fNearTop * 2;
	//var fNearBottom = -fNearTop;
	//var fNearRight = 50;
	//var fNearLeft = -fNearRight;
	var oEyeToSceenMatrix = new Matrix4x4();
	
	oEyeToSceenMatrix.zero();
	oEyeToSceenMatrix.set(0, 0, fNearTopx2 / (fNearRight - fNearLeft));
	oEyeToSceenMatrix.set(1, 1, fNearTopx2 / (fNearTop - fNearBottom));
	oEyeToSceenMatrix.set(2, 2, fNearTopx2 / (fFar - this.viewZ));
	oEyeToSceenMatrix.set(2, 3, 1);
	oEyeToSceenMatrix.set(3, 2, -((fNearTopx2 * fFar) / (fFar - this.viewZ)));
	
	this.worldToScreenMatrix = oEyeToSceenMatrix.multiplyMatrix(oWorldToEyeMatrix);
} // Projection2D
ProspectiveProjection.prototype = new Projection();

ProspectiveProjection.prototype.project = function (inPoint3D)
{
	var oPointMatrix = new Matrix(1, 4);
	
	oPointMatrix.set(0, 0, inPoint3D.x);
	oPointMatrix.set(0, 1, inPoint3D.y);
	oPointMatrix.set(0, 2, inPoint3D.z);
	oPointMatrix.set(0, 3, 1);
	
	//var oNewPointMatrix = this.worldToScreenMatrix.multiplyMatrix(oPointMatrix);
	var oNewPointMatrix = oPointMatrix.multiplyMatrix(this.worldToScreenMatrix);
	var oNewPoint = new Point(oNewPointMatrix.get(0, 0), oNewPointMatrix.get(0, 1));
	
	return oNewPoint;
} // project

/////////////////////////////////////////////////////////////////////////////////
function Shape3D()
{
	this.x = 0;
	this.y = 0;
	this.z = 0;
	this.width = 0;
	this.height = 0;
	this.depth = 0;
	this.visible = true;
	this.children = new Array();
	this.drawColor = null;
	this.fillColor = null;
} // Shape

Shape3D.prototype.addShape = function (inShape3D)
{
 	this.children.push(inShape3D);
} // addShape

Shape3D.prototype.removeShape = function (inShape3D)
{
	for (var iLoop1 = 0; iLoop1 < this.children.length; iLoop1++)
	{
		var oShape = this.children[iLoop1];
		
		if (false == oShape.equals(inShape3D))
			continue; // for
		
		oShape.view = null;
		this.children.splice(iLoop1, 1);
	} // for
} // removeShape

Shape3D.prototype.getArea = function ()
{
	return this.width * this.height;
} // getArea

Shape3D.prototype.getVolume = function ()
{
	return this.width * this.height * this.depth;
} // getVolume

Shape3D.prototype.containsPoint = function (inPoint3D)
{
	if (inPoint3D.x < this.x)
		return false;
 	if (inPoint3D.x > this.x + this.width)
		return false;
 	if (inPoint3D.y < this.y)
		return false;
 	if (inPoint3D.y > this.y + this.height)
		return false;
 	if (inPoint3D.z < this.z)
		return false;
 	if (inPoint3D.z > this.z + this.depth)
		return false;
		
 	return true;
} // containsPoint

Shape3D.prototype.isEqual = function (inShape3D)
{
	if (this.x != inShape3D.x)
		return false;
	if (this.y != inShape3D.y)
		return false;
	if (this.z != inShape3D.z)
		return false;
	if (this.width != inShape3D.width)
		return false;
	if (this.height != inShape3D.height)
		return false;
	if (this.depth != inShape3D.depth)
		return false;
	for (var iLoop1 = 0; iLoop1 < this.children.length; iLoop1++)
	{
		if (false == this.children[iLoop1].isEqual(inShape3D.children[iLoop1]))
			return false;
	} // for
		
	return true;
} // isEqual

Shape3D.prototype.draw = function (inView3D)
{
} // draw

Shape3D.prototype.drawChildren = function (inView3D)
{
	for (var iLoop1 = 0; iLoop1 < this.children.length; iLoop1++)
	{
		var oChildShape = this.children[iLoop1];
		
		oChildShape.draw(inView3D);
		oChildShape.drawChildren(inView3D);
	} // for
} // drawChildren

Shape3D.prototype.erase = function (inView3D)
{
	var oDrawColor = this.drawColor;
	var oEventInfo = this.eventInfo;
	
	this.drawColor = inView3D.backgroundColor;
	this.setEventInfo(inView3D.eventInfo);
	this.draw(inView3D, true);
	this.drawColor = oDrawColor;
	this.setEventInfo(oEventInfo);
} // erase

Shape3D.prototype.eraseChildren = function (inView3D)
{
	for (var iLoop1 = 0; iLoop1 < this.children.length; iLoop1++)
	{
		var oChildShape = this.children[iLoop1];
		
		oChildShape.erase(inView3D);
		oChildShape.eraseChildren(inView3D);
	} // for
} // eraseChildren

Shape3D.prototype.fill = function (inView3D, inEraseFlag)
{
 	this.draw(inView3D);
} // fill

Shape3D.prototype.fillChildren = function (inView3D)
{
	for (var iLoop1 = 0; iLoop1 < this.children.length; iLoop1++)
	{
		var oChildShape = this.children[iLoop1];
		
		oChildShape.fill(inView3D);
		oChildShape.fillChildren(inView3D);
	} // for
} // fillChildren

Shape3D.prototype.empty = function (inView3D)
{
 	var oFillColor = this.drawColor;
	var oEventInfo = this.eventInfo;
	
	this.fillColor = inView3D.backgroundColor;
	this.setEventInfo(inView3D.eventInfo);
	this.fill(inView3D);
	this.fillColor = oFillColor;
	this.setEventInfo(oEventInfo);
} // empty

Shape3D.prototype.emptyChildren = function (inView3D)
{
	for (var iLoop1 = 0; iLoop1 < this.children.length; iLoop1++)
	{
		var oChildShape = this.children[iLoop1];
		
		oChildShape.empty(inView3D);
		oChildShape.emptyChildren(inView3D);
	} // for
} // emptyChildren

Shape3D.prototype.setEventInfo = function (inEventInfo)
{
	this.eventInfo = inEventInfo;
} // setEventInfo

/////////////////////////////////////////////////////////////////////////////////
function Point3D(inX, inY, inZ, inDrawColor, inFillColor)
{
	this.x = inX;
	this.y = inY;
	this.z = inZ;
	this.width = 0;
	this.height = 0;
	this.depth = 0;
	this.parent = "Shape";
	this.drawColor = inDrawColor;
	this.fillColor = inFillColor;
} // Point3D
Point3D.prototype = new Shape3D();

Point3D.prototype.getCopy = function ()
{
	var oPoint = new Point3D(this.x, this.y, this.z, this.drawColor, this.fillColor);
	 
	oPoint.setEventInfo(this.eventInfo);
	return oPoint;
} // getCopy

Point3D.prototype.add = function (inPoint3D)
{
	var oPt = this.getCopy();
	
	oPt.x += inPoint3D.x;
	oPt.y += inPoint3D.y;
	oPt.z += inPoint3D.z;
	return oPt;
} // add

Point3D.prototype.subtract = function (inPoint3D)
{
	var oPt = this.getCopy();
	
	oPt.x -= inPoint3D.x;
	oPt.y -= inPoint3D.y;
	oPt.z -= inPoint3D.z;
	return oPt;
} // subtract

Point3D.prototype.getDistanceSquared = function (inPoint3D)
{
	var fXDistance = this.x - inPoint3D.x;
	var fYDistance = this.y - inPoint3D.y;
	var fZDistance = this.z - inPoint3D.z;
	var fDistanceSquared = fXDistance * fXDistance + fYDistance * fYDistance + fZDistance * fZDistance;
	
	return fDistanceSquared;
} // getDistanceSquared

Point3D.prototype.average = function(inPoint3D)
{
	var oAveragePoint = new Point3D();
	
	oAveragePoint.x = (this.x + inPoint3D.x) * 0.5;
	oAveragePoint.y = (this.y + inPoint3D.y) * 0.5;
	oAveragePoint.z = (this.z + inPoint3D.z) * 0.5;
	
	return oAveragePoint;
} // average

Point3D.prototype.dotProduct = function(inPoint3D)
{
	return this.x * inPoint3D.y + this.y * inPoint3D.x + this.z * inPoint3D.z;
} // dotProduct

Point3D.prototype.crossProduct = function(inPoint3D)
{
	return this.y * inPoint3D.z - inPoint3D.y * this.z , this.z * inPoint3D.x - inPoint3D.z * this.x , this.x * inPoint3D.y - inPoint3D.x * this.y;
} // crossProduct

Point3D.prototype.draw = function (inView)
{
	if (false == this.visible)
		return;
		
 	inView.setColor3D(this.x, this.y, this.z, this.drawColor);
	if (null != this.eventInfo)
		inView.setEvent3D(this.x, this.y, this.z, this.eventInfo, this);
} // draw

/////////////////////////////////////////////////////////////////////////////////
function Line3D(inStartPt3D, inEndPt3D, inDrawColor)
{
	this.start = inStartPt3D;
	this.end = inEndPt3D;
	this.x = Math.min(inStartPt3D.x, inEndPt3D.x);
	this.y = Math.min(inStartPt3D.y, inEndPt3D.y);
	this.z = Math.min(inStartPt3D.z, inEndPt3D.z);
	this.width = Math.max(inStartPt3D.x, inEndPt3D.x) - Math.min(inStartPt3D.x, inEndPt3D.x);
	this.height = Math.max(inStartPt3D.y, inEndPt3D.y) - Math.min(inStartPt3D.y, inEndPt3D.y);
	this.depth = Math.max(inStartPt3D.z, inEndPt3D.z) - Math.min(inStartPt3D.z, inEndPt3D.z);
	this.drawColor = inDrawColor;
	
	var aPoints = [];
    this.startPoint = inStartPt3D;
    this.endPoint = inEndPt3D;
 	this.drawColor = inDrawColor;

	var aPoints = [];
	var fCount = 0;
	var fDetailBias = 1 / 100; // Curve of 101 lines
			
	do
	{
		var fX = inStartPt3D.x * fCount + inEndPt3D.x * (1 - fCount);
		var fY = inStartPt3D.y * fCount + inEndPt3D.y * (1 - fCount);
		var fZ = inStartPt3D.z * fCount + inEndPt3D.z * (1 - fCount);
		var fPoint = new Point3D(Math.round(fX), Math.round(fY), Math.round(fZ), inDrawColor);

		aPoints.push(fPoint);
		fCount += fDetailBias;
	}while (fCount <= 1);
	
	this.points = aPoints;
	// TO DO: Is this right for 3D points?
	this.coefficientA = inStartPt3D.y - inEndPt3D.y;
	this.coefficientB = inEndPt3D.x - inStartPt3D.x;
	this.coefficientC = -0.5 * (this.coefficientA * (inStartPt3D.x + inEndPt3D.x) + this.coefficientB * (inStartPt3D.y + inEndPt3D.y));
} // Line3D
Line3D.prototype = new Shape3D();

Line3D.prototype.getArea = function ()
{
	return 0;
} // getArea

Line3D.prototype.isEqual = function (inLine)
{
	if ((this.start.isEqual(inLine.start))
	&& (this.end.isEqual(inLine.end)))
		return true;
	if ((this.start.isEqual(inLine.end))
	&& (this.end.isEqual(inLine.start)))
		return true;
		
	return false;
} // isEqual

Line3D.prototype.containsPoint = function (inPt)
{
	var aPoints = this.points;
	
	for (var iLoop1 = 0; iLoop1 < aPoints.length; iLoop1++)
	{
		var oPoint = aPoints[iLoop1];
		
		if (true == oPoint.isEqual(inPt))
			return true;
	} // for
	return false;
} // containsPoint

Line3D.prototype.draw = function (inView)
{
	if (false == this.visible)
		return;
		
 	var aPoints = this.points;
	
	for (var iLoop1 = 0; iLoop1 < aPoints.length; iLoop1++)
	{
		var oPoint = aPoints[iLoop1];
		
		inView.setColor3D(oPoint.x, oPoint.y, oPoint.z, this.drawColor);
		if (null != this.eventInfo)
			inView.setEvent3D(oPoint.x, oPoint.y, oPoint.y, this.eventInfo, this);
	} // for
} // draw

/////////////////////////////////////////////////////////////////////////////////
function QuadraticCurve3D(inEndPoint1, inEndPoint2, inCenterPoint, inDrawColor)
{
    this.endPoint1 = inEndPoint1;
    this.endPoint2 = inEndPoint2;
    this.centerPoint = inCenterPoint;
	this.drawColor = inDrawColor;
	this.lines = [];
	
	var aPoints = [];
	var fCount = 0;
	var fDetailBias = 1 / 100; // Curve of 101 lines
			
	do
	{
		var fB1 = fCount * fCount;
		var fB2 = 2 * fCount * (1 - fCount);
		var fB3 = (1 - fCount) * (1 - fCount);
		var fEnd1XB1 = this.endPoint1.x * fB1;
		var fCenterXB2 = this.centerPoint.x * fB2;
		var fEnd2XB3 = this.endPoint2.x * fB3;
		var fEnd1YB1 = this.endPoint1.y * fB1;
		var fCenterYB2 = this.centerPoint.y * fB2;
		var fEnd2YB3 = this.endPoint2.y * fB3;
		var fX = fEnd1XB1 + fCenterXB2 + fEnd2XB3;
		var fY = fEnd1YB1 + fCenterYB2 + fEnd2YB3;
		var fZ = fEnd1ZB1 + fCenterZB2 + fEnd2ZB3;
		var fPoint = new Point3D(Math.round(fX), Math.round(fY), Math.round(fZ), inDrawColor);

		aPoints.push(fPoint);
		fCount += fDetailBias;
	}while (fCount <= 1);
	
	for (var iLoop1 = 0; iLoop1 < aPoints.length - 1; iLoop1++)
	{
		var oPoint1 = aPoints[iLoop1];
		var oPoint2 = aPoints[iLoop1 + 1];
		var oLine = new Line3D(oPoint1, oPoint2, inDrawColor);
		
		this.lines.push(oLine);
	} // for
} // QuadraticCurve3D
QuadraticCurve3D.prototype = new Shape3D();

QuadraticCurve3D.prototype.getArea = function ()
{
	return 0;
} // getArea

QuadraticCurve3D.prototype.isEqual = function (inQuadraticCurve)
{
	for (var iLoop1 = 0; iLoop1 < this.lines.length; iLoop1++)
	{
		var oThisLine = this.lines[iLoop1];
		var oInLine = inQuadraticCurve.lines[iLoop1];
		
		if (false == oThisLine.isEqual(oInLine))
			return false;
	} // for
		
	return true;
} // isEqual

QuadraticCurve3D.prototype.containsPoint = function (inPt)
{
	for (var iLoop1 = 0; iLoop1 < this.lines.length; iLoop1++)
	{
		var oLine = this.lines[iLoop1];
		
		if (true == oLine.containsPoint(inPt))
			return true;
	} // for
	return false;
} // containsPoint

QuadraticCurve3D.prototype.draw = function (inView)
{
	for (var iLoop1 = 0; iLoop1 < this.lines.length; iLoop1++)
	{
		var oLine = this.lines[iLoop1];
		
		oLine.drawColor = this.drawColor;
		oLine.setEventInfo3D(this.eventInfo);
		oLine.draw3D(inView);
	} // for
} // draw

/////////////////////////////////////////////////////////////////////////////////
function CubicCurve3D(inEndPoint1, inEndPoint2, inCenterPoint1, inCenterPoint2, inDrawColor)
{
    this.endPoint1 = inEndPoint1;
    this.endPoint2 = inEndPoint2;
    this.centerPoint1 = inCenterPoint1;
    this.centerPoint2 = inCenterPoint2;
	this.drawColor = inDrawColor;
	this.lines = [];
	
	var aPoints = [];
	var fCount = 0;
	var fDetailBias = 1 / 100; // Curve of 101 lines
			
	do
	{
		var fB1 = fCount * fCount* fCount;
		var fB2 = 3 * (fCount * fCount) * (1 - fCount);
		var fB3 = 3 * fCount * ((1 - fCount) * (1 - fCount));
		var fB4 = (1 - fCount) * (1 - fCount) * (1 - fCount);
		var fEnd1XB1 = this.endPoint1.x * fB1;
		var fCenter1XB2 = this.centerPoint1.x * fB2;
		var fCenter2XB3 = this.centerPoint1.x * fB3;
		var fEnd2XB4 = this.endPoint2.x * fB4;
		var fEnd1YB1 = this.endPoint1.y * fB1;
		var fCenter1YB2 = this.centerPoint1.y * fB2;
		var fCenter2YB3 = this.centerPoint1.y * fB3;
		var fEnd2YB4 = this.endPoint2.y * fB4;
		var fX = fEnd1XB1 + fCenter1XB2 + fCenter2XB3 + fEnd2XB4;
		var fY = fEnd1YB1 + fCenter1YB2 + fCenter2YB3 + fEnd2YB4;
		var fZ = fEnd1ZB1 + fCenter1ZB2 + fCenter2ZB3 + fEnd2ZB4;
		var fPoint = new Point3D(Math.round(fX), Math.round(fY), Math.round(fZ), inDrawColor);

		aPoints.push(fPoint);
		fCount += fDetailBias;
	}while (fCount <= 1);
	
	for (var iLoop1 = 0; iLoop1 < aPoints.length - 1; iLoop1++)
	{
		var oPoint1 = aPoints[iLoop1];
		var oPoint2 = aPoints[iLoop1 + 1];
		var oLine = new Line3D(oPoint1, oPoint2, inDrawColor);
		
		this.lines.push(oLine);
	} // for
} // CubicCurve3D
CubicCurve3D.prototype = new Shape3D();

CubicCurve3D.prototype.getArea = function ()
{
	return 0;
} // getArea

CubicCurve3D.prototype.isEqual = function (inQuadraticCurve)
{
	for (var iLoop1 = 0; iLoop1 < this.lines.length; iLoop1++)
	{
		var oThisLine = this.lines[iLoop1];
		var oInLine = inQuadraticCurve.lines[iLoop1];
		
		if (false == oThisLine.isEqual(oInLine))
			return false;
	} // for
		
	return true;
} // isEqual

CubicCurve3D.prototype.containsPoint = function (inPt)
{
	for (var iLoop1 = 0; iLoop1 < this.lines.length; iLoop1++)
	{
		var oLine = this.lines[iLoop1];
		
		if (true == oLine.containsPoint(inPt))
			return true;
	} // for
	return false;
} // containsPoint

CubicCurve3D.prototype.draw = function (inView)
{
	for (var iLoop1 = 0; iLoop1 < this.lines.length; iLoop1++)
	{
		var oLine = this.lines[iLoop1];
		
		oLine.drawColor = this.drawColor;
		oLine.setEventInfo3D(this.eventInfo);
		oLine.draw3D(inView);
	} // for
} // draw

/////////////////////////////////////////////////////////////////////////////////
function Triangle3D(inPoint1, inPoint2, inPoint3, inDrawColor, inFillColor)
{
	TO DO: Game Progamming Gems, Volume 1, Section 4.5 has a (somewhat long)
	algorithim for check points inside triangles.
	this.point1 = inPoint1;
	this.point2 = inPoint2;
	this.point3 = inPoint3;
	this.drawColor = inDrawColor;
	this.fillColor = inFillColor;
	
	var iMinX = Math.min(this.point1.x, this.point2.x);
	var iMaxX = Math.max(this.point1.x, this.point2.x);
	var iMinY = Math.min(this.point1.y, this.point2.y);
	var iMaxY = Math.max(this.point1.y, this.point2.y);
	var iMinZ = Math.min(this.point1.z, this.point2.z);
	var iMaxZ = Math.max(this.point1.z, this.point2.z);
	
	iMinX = Math.min(iMinX, this.point3.x);
	iMaxX = Math.max(iMaxX, this.point3.x);
	iMinY = Math.min(iMinY, this.point3.y);
	iMaxY = Math.max(iMaxY, this.point3.y);
	iMinZ = Math.min(iMinZ, this.point3.z);
	iMaxZ = Math.max(iMaxZ, this.point3.z);
	
	this.x = iMinX;
	this.y = iMinY;
	this.z = iMinZ;
	this.width = iMaxX - iMinX;
	this.height = iMaxY - iMinY;
	this.depth = iMaxZ - iMinZ;
} // Triangle3D
Triangle3D.prototype = new Shape3D();

Triangle3D.prototype.getArea = function ()
{
	// Rotate the triangle into 2D and take 1/2 the
	// area of its bounding box.
	var fArea = this.width * this.height / 2;
	
	return fArea;
} // getArea

Triangle3D.prototype.containsPoint = function (inPoint)
{
	var oTriangle1 = new Triangle3D(inPoint, this.point1, this.point2);
	var oTriangle2 = new Triangle3D(inPoint, this.point2, this.point3);
	var oTriangle3 = new Triangle3D(inPoint, this.point1, this.point3);
	var fArea1 = oTriangle1.getArea();
	var fArea2 = oTriangle2.getArea();
	var fArea3 = oTriangle3.getArea();
	
	return ((fArea1 + fArea2 + fArea3) == this.getArea());
} // containsPoint

Triangle3D.prototype.isEqual = function (inTriangle)
{
	var aPoints = [];
	var bPoint1Matched = false;
	var bPoint2Matched = false;
	var bPoint3Matched = false;
	
	aPoints.push(inTriangle.point1);
	aPoints.push(inTriangle.point2);
	aPoints.push(inTriangle.point3);
	
	for (var iLoop1 = 0; iLoop1 < aPoints.length; iLoop1++)
	{
		var oPoint = aPoints[iLoop1];
		
		if (false == this.point1.isEqual(oPoint))
			continue; // for
			
		bPoint1Matched = true;
		aPoints.splice(iLoop1, 1);
	} // for
	if (false == bPoint1Matched)
		return false;
	
	for (var iLoop2 = 0; iLoop2 < aPoints.length; iLoop2++)
	{
		var oPoint = aPoints[iLoop2];
		
		if (false == this.point2.isEqual(oPoint))
			continue; // for
			
		bPoint2Matched = true;
		aPoints.splice(iLoop2, 1);
	} // for
	if (false == bPoint2Matched)
		return false;
	
	for (var iLoop3 = 0; iLoop3 < aPoints.length; iLoop3++)
	{
		var oPoint = aPoints[iLoop3];
		
		if (false == this.point3.isEqual(oPoint))
			continue; // for
			
		bPoint3Matched = true;
		aPoints.splice(iLoop3, 1);
	} // for
	if (false == bPoint3Matched)
		return false;
		
	return true;
} // isEqual

Triangle3D.prototype.isClockwise = function ()
{
	// Convert triangle to 2D and see if 3rd point is on the right of points 1 and 2.
	var fX1 = this.point2.x - this.point1.x;
	var fY1 = this.point2.y - this.point1.y;
	var fX2 = this.point3.x - this.point1.x;
	var fY2 = this.point3.y - this.point1.y;
	var fSide = (fX1 * fY2) - (fY1 * fX2);
	
	return (fSide < 0.0);
} // isClockwise

Triangle3D.prototype.draw = function(inView)
{
	if (false == this.visible) 
		return;
	
	var oLine1 = new Line3D(this.point1, this.point2, this.drawColor);
	var oLine2 = new Line(this.point2, this.point3, this.drawColor);
	var oLine3 = new Line(this.point3, this.point1, this.drawColor);
	
	oLine1.setEventInfo(this.eventInfo);
	oLine2.setEventInfo(this.eventInfo);
	oLine3.setEventInfo(this.eventInfo);
	oLine1.draw(inView);
	oLine2.draw(inView);
	oLine3.draw(inView);
} // draw

Triangle3D.prototype.fill = function (inView)
{
	if (false == this.visible)
		return;
		
	var oLine1 = new Line3D(this.point1, this.point2, this.drawColor);
	var oLine2 = new Line3D(this.point2, this.point3, this.drawColor);
	var oLine3 = new Line3D(this.point3, this.point1, this.drawColor);
	var fEdge1 = oLine1.coefficientA * this.x + oLine1.coefficientB * this.y + oLine1.coefficientC;
	var fEdge2 = oLine2.coefficientA * this.x + oLine2.coefficientB * this.y + oLine2.coefficientC;
	var fEdge3 = oLine3.coefficientA * this.x + oLine3.coefficientB * this.y + oLine3.coefficientC;
		
	for (var iLoop1 = this.y; iLoop1 <= this.height; iLoop1++)
	{
		var fEdge1T = fEdge1;
		var fEdge2T = fEdge2;
		var fEdge3T = fEdge3;
		
		for (var iLoop2 = this.x; iLoop2 <= this.width; iLoop2++)
		{
			var bEdge1Positive = ((fEdge1 > 0)? true : false);
			var bEdge2Positive = ((fEdge2 > 0)? true : false);
			var bEdge3Positive = ((fEdge3 > 0)? true : false);
			
			if ((bEdge1Positive == bEdge2Positive)
			&& (bEdge2Positive == bEdge3Positive))
			{
				inView.setColor(iLoop2, iLoop1, this.fillColor);
				if (null != this.eventInfo)
					inView.setEvent(iLoop2, iLoop1, this.eventInfo, this);
			} // if
			
			fEdge1 = fEdge1 + oLine1.coefficientA;
			fEdge2 = fEdge2 + oLine2.coefficientA;
			fEdge3 = fEdge3 + oLine3.coefficientA;
		} // for
			
		fEdge1 = fEdge1T + oLine1.coefficientB;
		fEdge2 = fEdge2T + oLine2.coefficientB;
		fEdge3 = fEdge3T + oLine3.coefficientB;
	} // for
} // fill

/////////////////////////////////////////////////////////////////////////////////
function View3D(inX, inY, inZ, inWidth, inHeight, inDepth, inID, inParent, inDocument, inBackgroundColor)
{
	this.x = inX;
	this.y = inY;
	this.z = inZ;
	this.width = inWidth;
	this.height = inHeight;
	this.depth = inDepth;
	this.id = inID;
	this.parent = inParent;
	this.styles = new Array();
	this.cells = new Array();
	this.projection = new ProspectiveProjection(this, new Vertex3D(0, 0, 1), new Vertex3D(0, 0, 0), new Vertex3D(0, 1, 0));
	this.projection2D = new Projection();
	this.children = new Array();
	this.backgroundColor = inBackgroundColor;
	if (null == this.backgroundColor)
		this.backgroundColor = new Color(0, 0, 0, 0, true);
	
	var oTable = inDocument.createElement("TABLE");

	oTable.id = inID;
	oTable.name = inID;
	inParent.appendChild(oTable);
	oTable.setAttribute("CELLPADDING", "0");
	oTable.setAttribute("CELLSPACING", "0");
	oTable.style.position = "absolute";

	for (var iLoop1 = inHeight - inY - 1; iLoop1 >= inY ; iLoop1--)
	{
		var oTR = inDocument.createElement("TR");
		var strRow = "" + inID + "_" + iLoop1;
		
		oTR.id = strRow;
		oTR.name = strRow;
		oTable.appendChild(oTR);
		this.styles[iLoop1] = new Array();
		this.cells[iLoop1] = new Array();
		
		for (var iLoop2 = inX; iLoop2 < inWidth - inX; iLoop2++)
		{
			var oTD = inDocument.createElement("TD");
			var strRowColumn = "" + inID + "_" + iLoop1 + "_" + iLoop2;
			
			oTD.id = strRowColumn;
			oTD.name = strRowColumn;
			oTD.style.backgroundColor = this.backgroundColor.toString();
			oTD.style.width = "1px";
			oTD.style.height = "1px";
			oTD.style.fontSize = "1px";
			oTR.appendChild(oTD);
			this.styles[iLoop1][iLoop2] = oTD.style;
			this.cells[iLoop1][iLoop2] = oTD;
			
			var oText = document.createTextNode(" ");
			oTD.appendChild(oText);
		} // for
	} // for
} // View
View3D.prototype = new Shape();

View3D.prototype.setColor = function (inX, inY, inColor)
{
	var oProjection = this.projection;
	
	this.projection = this.projection2D;
 	this.setColor3D(inX, inY, 0, inColor);
	this.projection = oProjection;
} // setColor

View3D.prototype.setColor3D = function (inX, inY, inZ, inColor)
{		
 	var oPoint3D = new Point3D(inX, inY, inZ);
	var oPoint = this.projection.project(oPoint3D);
	var fX = Math.round(oPoint.x) - this.x;
	var fY = Math.round(oPoint.y) - this.y;
	
	if (fX< this.x)
		return;
 	if (fX >= this.width - this.x)
		return;
 	if (fY < this.y)
		return;
 	if (fY >= this.height - this.y)
		return;
	
	var oStyle = this.styles[fY][fX];
	
	oStyle.backgroundColor = inColor.toString();
	oStyle.opacity = inColor.toOpacityString();
	oStyle.filter = inColor.toFilterString();
} // setColor3D

View3D.prototype.getColor = function (inX, inY)
{
	var oProjection = this.projection;
	
	this.projection = this.projection2D;
	return this.getColor3D(inX, inY, 0);
	this.projection = oProjection;
} // getColor

View3D.prototype.getColor3D = function (inX, inY, inZ)
{
	var oPoint3D = new Point3D(inX, inY, inZ);
	var oPoint = this.projection.project(oPoint3D);
 	var fX = Math.round(oPoint.x) - this.x;
	var fY = Math.round(oPoint.y) - this.y;
	
	if (inX < this.x)
		return null;
 	if (inX >= this.width - this.x)
		return null;
 	if (inY < this.y)
		return null;
 	if (inY >= this.height - this.y)
		return null;
		
 	var oStyle = this.styles[fY][fX];
	var oColor = new Color();
	
	oColor.fromString(oStyle.backgroundColor);
	oColor.fromOpacityString(oStyle.opacity);
	oColor.fromFilterString(oStyle.filter);
	return oColor;
} // getColor3D

View3D.prototype.setBackgroundColor = function (inColor)
{
 	this.backgroundColor = inColor;
} // setBackgroundColor

View3D.prototype.setEvent = function (inX, inY, inEventInfo, inShape)
{
	var oProjection = this.projection;
	
	this.projection = this.projection2D;
	this.setEvent3D(inX, inY, 0, inEventInfo, inShape);
	this.projection = oProjection;
} // setEvent

View3D.prototype.setEvent3D = function (inX, inY, inZ, inEventInfo, inShape)
{
	var oPoint3D = new Point3D(inX, inY, inZ);
	var oPoint = this.projection.project(oPoint3D);
  	var fX = Math.round(oPoint.x) - this.x;
	var fY = Math.round(oPoint.y) - this.y;
	
	if (fX < this.x)
		return;
 	if (fX >= this.width - this.x)
		return;
 	if (fY < this.y)
		return;
 	if (fY >= this.height - this.y)
		return;
 	if (null == inEventInfo)
		return;
 	if (null == inShape)
		return;
	
	var oCell = this.cells[fY][fX];

	if (null != inEventInfo.mouseClickInfo)
	{
		if (null != inEventInfo.mouseClickInfo.mouseClickFunction)
			oCell.onclick = this.makeEventFunction(inShape, inEventInfo.mouseClickInfo.mouseClickFunction, inEventInfo.mouseClickInfo.mouseClickColor, inEventInfo.mouseClickInfo.mouseClickFillColor);
		if (null != inEventInfo.mouseClickInfo.mouseDoubleClickFunction)
			oCell.ondblclick = this.makeEventFunction(inShape, inEventInfo.mouseClickInfo.mouseDoubleClickFunction, inEventInfo.mouseClickInfo.mouseDoubleClickColor, inEventInfo.mouseClickInfo.mouseDoubleClickFillColor);
		if (null != inEventInfo.mouseClickInfo.mouseDownFunction)
			oCell.onmousedown = this.makeEventFunction(inShape, inEventInfo.mouseClickInfo.mouseDownFunction, inEventInfo.mouseClickInfo.mouseDownColor, inEventInfo.mouseClickInfo.mouseDownFillColor);
		if (null != inEventInfo.mouseClickInfo.mouseUpFunction)
			oCell.onmouseup = this.makeEventFunction(inShape, inEventInfo.mouseClickInfo.mouseUpFunction, inEventInfo.mouseClickInfo.mouseUpColor, inEventInfo.mouseClickInfo.mouseUpFillColor);
	} // if
	if (null != inEventInfo.mouseMoveInfo)
	{
		if (null != inEventInfo.mouseMoveInfo.mouseOverFunction)
			oCell.onmouseover = this.makeEventFunction(inShape, inEventInfo.mouseMoveInfo.mouseOverFunction, inEventInfo.mouseMoveInfo.mouseOverColor, inEventInfo.mouseMoveInfo.mouseOverFillColor);
		if (null != inEventInfo.mouseMoveInfo.mouseOutFunction)
			oCell.onmouseout = this.makeEventFunction(inShape, inEventInfo.mouseMoveInfo.mouseOutFunction, inEventInfo.mouseMoveInfo.mouseOutColor, inEventInfo.mouseMoveInfo.mouseOutFillColor);
	} // if
} // setEvent3D

View3D.prototype.makeEventFunction = function(inShape, inEventFunction, inEventColor, inEventFillColor)
{
	var oThisView = this;
	var oEventFunction = function()
	{
		if (null != inEventColor)
		{
			inShape.drawColor = inEventColor;
			inShape.draw(oThisView);
		} // if
		if (null != inEventFillColor)
		{
			inShape.fillColor = inEventFillColor;
			inShape.fill(oThisView);
		} // if
		inEventFunction();
	} // oEventFunction
	
	return oEventFunction;
} // makeEventFunction

View3D.prototype.setZIndex = function (inZIndex)
{
	for (var iLoop1 = this.y; iLoop1 < this.height - this.y; iLoop1++)
	{		
		for (var iLoop2 = this.x; iLoop2 < this.width - this.x; iLoop2++)
		{
			var oTDStyle = this.styles[iLoop1][iLoop2];
			
			oTDStyle.zIndex = inZIndex;
		} // for
	} // for
} // setZIndex

View3D.prototype.emptyBackground = function ()
{
	var iMaxX = this.width - this.x;
	var iMaxY = this.height - this.y;
	
 	for (var iLoop1 = this.x; iLoop1 < iMaxX; iLoop1++)
	{
	 	for (var iLoop2 = this.y; iLoop2 < iMaxY; iLoop2++)
		{
			this.setColor(iLoop1, iLoop2, this.backgroundColor);
		} // for
	} // for
} // emptyBackground

View3D.prototype.draw = function (inView3D)
{
 	this.drawChildren(this);
} // draw

View3D.prototype.erase = function (inView3D)
{
 	this.eraseChildren(this);
} // erase

View3D.prototype.fill = function (inView3D)
{
 	this.fillChildren(this);
} // fill

View3D.prototype.empty = function (inView3D)
{
 	this.emptyChildren(this);
} // empty
